import{s as xe,o as Me,n as Ge}from"../chunks/scheduler.d6170356.js";import{S as be,i as ke,g as s,s as l,r as g,A as Ce,h as a,f as i,c as o,j as $e,u as f,x as r,k as Zt,y as Pe,a as n,v as c,d,t as h,w as y,m as we,n as Te}from"../chunks/index.fcd4cc08.js";import{T as Le}from"../chunks/Tip.b09c67cf.js";import{C as qt}from"../chunks/CodeBlock.7b16bdef.js";import{H as lt}from"../chunks/Heading.8660bd0e.js";function He(ot){let m,p,$="git config --global commit.gpgsign true",v;return{c(){m=we("To sign all commits by default in any local repository on your computer, you can run "),p=s("code"),p.textContent=$,v=we(".")},l(u){m=Te(u,"To sign all commits by default in any local repository on your computer, you can run "),p=a(u,"CODE",{"data-svelte-h":!0}),r(p)!=="svelte-1je77r9"&&(p.textContent=$),v=Te(u,".")},m(u,w){n(u,m,w),n(u,p,w),n(u,v,w)},p:Ge,d(u){u&&(i(m),i(p),i(v))}}}function _e(ot){let m,p,$,v,u,w,G,Ot="<code>git</code> has an authentication layer to control who can push commits to a repo, but it does not authenticate the actual commit authors.",st,b,Nt="In other words, you can commit changes as <code>Elon Musk &lt;elon@tesla.com&gt;</code>, push them to your preferred <code>git</code> host (for instance github.com), and your commit will link to Elon’s GitHub profile. (Try it! But don’t blame us if Elon gets mad at you for impersonating him.)",at,k,zt="The reasons we implemented GPG signing were:",rt,C,Qt="<li>To provide finer-grained security, especially as more and more Enterprise users rely on the Hub.</li> <li>To provide ML benchmarks backed by a cryptographically-secure source.</li>",ut,P,Vt='See Ale Segala’s <a href="https://withblue.ink/2020/05/17/how-and-why-to-sign-git-commits.html" rel="nofollow">How (and why) to sign <code>git</code> commits</a> for more context.',mt,L,Dt="You can prove a commit was authored by you with GNU Privacy Guard (GPG) and a key server. GPG is a cryptographic tool used to verify the authenticity of a message’s origin. We’ll explain how to set this up on Hugging Face below.",pt,H,Kt='The Pro Git book is, as usual, a good resource about commit signing: <a href="https://git-scm.com/book/en/v2/Git-Tools-Signing-Your-Work" rel="nofollow">Pro Git: Signing your work</a>.',gt,_,ft,E,Xt='You will need to install <a href="https://gnupg.org/" rel="nofollow">GPG</a> on your system in order to execute the following commands.',ct,U,Rt=`<p>It’s included by default in most Linux distributions.
On Windows, it is included in Git Bash (which comes with <code>git</code> for Windows).</p>`,dt,S,te=`You can sign your commits locally using <a href="https://gnupg.org/" rel="nofollow">GPG</a>.
Then configure your profile to mark these commits as <strong>verified</strong> on the Hub,
so other people can be confident that they come from a trusted source.`,ht,I,ee='For a more in-depth explanation of how git and GPG interact, please visit the the <a href="https://git-scm.com/book/en/v2/Git-Tools-Signing-Your-Work" rel="nofollow">git documentation on the subject</a>',yt,J,ie="Commits can have the following signing statuses:",vt,W,ne="<thead><tr><th>Status</th> <th>Explanation</th></tr></thead> <tbody><tr><td>Verified</td> <td>The commit is signed and the signature is verified</td></tr> <tr><td>Unverified</td> <td>The commit is signed but the signature could not be verified</td></tr> <tr><td>No signing status</td> <td>The commit is not signed</td></tr></tbody>",$t,Y,le="For a commit to be marked as <strong>verified</strong>, you need to upload the public key used to sign it on your Hugging Face account.",wt,j,oe=`Use the <code>gpg --list-secret-keys</code> command to list the GPG keys for which you have both a public and private key.
A private key is required for signing commits or tags.`,Tt,B,se="If you don’t have a GPG key pair or you don’t want to use the existing keys to sign your commits, go to <strong>Generating a new GPG key</strong>.",xt,F,ae='Otherwise, go straight to  <a href="#adding-a-gpg-key-to-your-account">Adding a GPG key to your account</a>.',Mt,A,Gt,Z,re="To generate a GPG key, run the following:",bt,q,kt,O,ue="GPG will then guide you through the process of creating a GPG key pair.",Ct,N,me='Make sure you specify an email address for this key, and that the email address matches the one you specified in your Hugging Face <a href="https://huggingface.co/settings/account" rel="nofollow">account</a>.',Pt,z,Lt,Q,pe='<li><p>First, select or generate a GPG key on your computer. Make sure the email address of the key matches the one in your Hugging Face <a href="https://huggingface.co/settings/account" rel="nofollow">account</a> and that the email of your account is verified.</p></li> <li><p>Export the public part of the selected key:</p></li>',Ht,V,_t,T,ge='<li>Then visit your profile <a href="https://huggingface.co/settings/keys" rel="nofollow">settings page</a> and click on <strong>Add GPG Key</strong>.</li>',Et,D,fe="Copy &amp; paste the output of the <code>gpg --export</code> command in the text area and click on <strong>Add Key</strong>.",Ut,x,ce="<li>Congratulations! 🎉  You’ve just added a GPG key to your account!</li>",St,K,It,X,de="The last step is to configure git to sign your commits:",Jt,R,Wt,tt,he="Then add the <code>-S</code> flag to your <code>git commit</code> commands to sign your commits!",Yt,et,jt,it,ye="Once pushed on the Hub, you should see the commit with a “Verified” badge.",Bt,M,Ft,nt,At;return u=new lt({props:{title:"Signing commits with GPG",local:"signing-commits-with-gpg",headingTag:"h1"}}),_=new lt({props:{title:"Setting up signed commits verification",local:"setting-up-signed-commits-verification",headingTag:"h2"}}),A=new lt({props:{title:"Generating a new GPG key",local:"generating-a-new-gpg-key",headingTag:"h2"}}),q=new qt({props:{code:"Z3BnJTIwLS1nZW4ta2V5",highlighted:"gpg --gen-key",wrap:!1}}),z=new lt({props:{title:"Adding a GPG key to your account",local:"adding-a-gpg-key-to-your-account",headingTag:"h2"}}),V=new qt({props:{code:"Z3BnJTIwLS1hcm1vciUyMC0tZXhwb3J0JTIwJTNDWU9VUiUyMEtFWSUyMElEJTNF",highlighted:'gpg --armor --<span class="hljs-built_in">export</span> &lt;YOUR KEY ID&gt;',wrap:!1}}),K=new lt({props:{title:"Configure git to sign your commits with GPG",local:"configure-git-to-sign-your-commits-with-gpg",headingTag:"h2"}}),R=new qt({props:{code:"Z2l0JTIwY29uZmlnJTIwdXNlci5zaWduaW5na2V5JTIwJTNDWW91ciUyMEdQRyUyMEtleSUyMElEJTNFJTBBZ2l0JTIwY29uZmlnJTIwdXNlci5lbWFpbCUyMCUzQ1lvdXIlMjBlbWFpbCUyMG9uJTIwaGYuY28lM0U=",highlighted:`git config user.signingkey &lt;Your GPG Key ID&gt;
git config user.email &lt;Your email on hf.co&gt;`,wrap:!1}}),et=new qt({props:{code:"Z2l0JTIwY29tbWl0JTIwLVMlMjAtbSUyMCUyMk15JTIwZmlyc3QlMjBzaWduZWQlMjBjb21taXQlMjI=",highlighted:'git commit -S -m <span class="hljs-string">&quot;My first signed commit&quot;</span>',wrap:!1}}),M=new Le({props:{$$slots:{default:[He]},$$scope:{ctx:ot}}}),{c(){m=s("meta"),p=l(),$=s("p"),v=l(),g(u.$$.fragment),w=l(),G=s("p"),G.innerHTML=Ot,st=l(),b=s("p"),b.innerHTML=Nt,at=l(),k=s("p"),k.textContent=zt,rt=l(),C=s("ul"),C.innerHTML=Qt,ut=l(),P=s("p"),P.innerHTML=Vt,mt=l(),L=s("p"),L.textContent=Dt,pt=l(),H=s("p"),H.innerHTML=Kt,gt=l(),g(_.$$.fragment),ft=l(),E=s("p"),E.innerHTML=Xt,ct=l(),U=s("blockquote"),U.innerHTML=Rt,dt=l(),S=s("p"),S.innerHTML=te,ht=l(),I=s("p"),I.innerHTML=ee,yt=l(),J=s("p"),J.textContent=ie,vt=l(),W=s("table"),W.innerHTML=ne,$t=l(),Y=s("p"),Y.innerHTML=le,wt=l(),j=s("p"),j.innerHTML=oe,Tt=l(),B=s("p"),B.innerHTML=se,xt=l(),F=s("p"),F.innerHTML=ae,Mt=l(),g(A.$$.fragment),Gt=l(),Z=s("p"),Z.textContent=re,bt=l(),g(q.$$.fragment),kt=l(),O=s("p"),O.textContent=ue,Ct=l(),N=s("p"),N.innerHTML=me,Pt=l(),g(z.$$.fragment),Lt=l(),Q=s("ol"),Q.innerHTML=pe,Ht=l(),g(V.$$.fragment),_t=l(),T=s("ol"),T.innerHTML=ge,Et=l(),D=s("p"),D.innerHTML=fe,Ut=l(),x=s("ol"),x.innerHTML=ce,St=l(),g(K.$$.fragment),It=l(),X=s("p"),X.textContent=de,Jt=l(),g(R.$$.fragment),Wt=l(),tt=s("p"),tt.innerHTML=he,Yt=l(),g(et.$$.fragment),jt=l(),it=s("p"),it.textContent=ye,Bt=l(),g(M.$$.fragment),Ft=l(),nt=s("p"),this.h()},l(t){const e=Ce("svelte-u9bgzb",document.head);m=a(e,"META",{name:!0,content:!0}),e.forEach(i),p=o(t),$=a(t,"P",{}),$e($).forEach(i),v=o(t),f(u.$$.fragment,t),w=o(t),G=a(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-16xioii"&&(G.innerHTML=Ot),st=o(t),b=a(t,"P",{"data-svelte-h":!0}),r(b)!=="svelte-1496un1"&&(b.innerHTML=Nt),at=o(t),k=a(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-iec5lg"&&(k.textContent=zt),rt=o(t),C=a(t,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-1ruuqle"&&(C.innerHTML=Qt),ut=o(t),P=a(t,"P",{"data-svelte-h":!0}),r(P)!=="svelte-y864g7"&&(P.innerHTML=Vt),mt=o(t),L=a(t,"P",{"data-svelte-h":!0}),r(L)!=="svelte-n96a7q"&&(L.textContent=Dt),pt=o(t),H=a(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-138n0c9"&&(H.innerHTML=Kt),gt=o(t),f(_.$$.fragment,t),ft=o(t),E=a(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-1p8rrlz"&&(E.innerHTML=Xt),ct=o(t),U=a(t,"BLOCKQUOTE",{"data-svelte-h":!0}),r(U)!=="svelte-osktdt"&&(U.innerHTML=Rt),dt=o(t),S=a(t,"P",{"data-svelte-h":!0}),r(S)!=="svelte-6aimav"&&(S.innerHTML=te),ht=o(t),I=a(t,"P",{"data-svelte-h":!0}),r(I)!=="svelte-10krbex"&&(I.innerHTML=ee),yt=o(t),J=a(t,"P",{"data-svelte-h":!0}),r(J)!=="svelte-b4b7dr"&&(J.textContent=ie),vt=o(t),W=a(t,"TABLE",{"data-svelte-h":!0}),r(W)!=="svelte-8x81wm"&&(W.innerHTML=ne),$t=o(t),Y=a(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-fgh5wb"&&(Y.innerHTML=le),wt=o(t),j=a(t,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1pe2s2l"&&(j.innerHTML=oe),Tt=o(t),B=a(t,"P",{"data-svelte-h":!0}),r(B)!=="svelte-okgo5j"&&(B.innerHTML=se),xt=o(t),F=a(t,"P",{"data-svelte-h":!0}),r(F)!=="svelte-1dhnlqh"&&(F.innerHTML=ae),Mt=o(t),f(A.$$.fragment,t),Gt=o(t),Z=a(t,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-emmsc9"&&(Z.textContent=re),bt=o(t),f(q.$$.fragment,t),kt=o(t),O=a(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-yy4ur9"&&(O.textContent=ue),Ct=o(t),N=a(t,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1u70yn5"&&(N.innerHTML=me),Pt=o(t),f(z.$$.fragment,t),Lt=o(t),Q=a(t,"OL",{"data-svelte-h":!0}),r(Q)!=="svelte-1wz0fdq"&&(Q.innerHTML=pe),Ht=o(t),f(V.$$.fragment,t),_t=o(t),T=a(t,"OL",{start:!0,"data-svelte-h":!0}),r(T)!=="svelte-1cndhv3"&&(T.innerHTML=ge),Et=o(t),D=a(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1gi8bl1"&&(D.innerHTML=fe),Ut=o(t),x=a(t,"OL",{start:!0,"data-svelte-h":!0}),r(x)!=="svelte-1wu31pe"&&(x.innerHTML=ce),St=o(t),f(K.$$.fragment,t),It=o(t),X=a(t,"P",{"data-svelte-h":!0}),r(X)!=="svelte-ui06bn"&&(X.textContent=de),Jt=o(t),f(R.$$.fragment,t),Wt=o(t),tt=a(t,"P",{"data-svelte-h":!0}),r(tt)!=="svelte-t1hkz2"&&(tt.innerHTML=he),Yt=o(t),f(et.$$.fragment,t),jt=o(t),it=a(t,"P",{"data-svelte-h":!0}),r(it)!=="svelte-j4g221"&&(it.textContent=ye),Bt=o(t),f(M.$$.fragment,t),Ft=o(t),nt=a(t,"P",{}),$e(nt).forEach(i),this.h()},h(){Zt(m,"name","hf:doc:metadata"),Zt(m,"content",Ee),Zt(T,"start","3"),Zt(x,"start","4")},m(t,e){Pe(document.head,m),n(t,p,e),n(t,$,e),n(t,v,e),c(u,t,e),n(t,w,e),n(t,G,e),n(t,st,e),n(t,b,e),n(t,at,e),n(t,k,e),n(t,rt,e),n(t,C,e),n(t,ut,e),n(t,P,e),n(t,mt,e),n(t,L,e),n(t,pt,e),n(t,H,e),n(t,gt,e),c(_,t,e),n(t,ft,e),n(t,E,e),n(t,ct,e),n(t,U,e),n(t,dt,e),n(t,S,e),n(t,ht,e),n(t,I,e),n(t,yt,e),n(t,J,e),n(t,vt,e),n(t,W,e),n(t,$t,e),n(t,Y,e),n(t,wt,e),n(t,j,e),n(t,Tt,e),n(t,B,e),n(t,xt,e),n(t,F,e),n(t,Mt,e),c(A,t,e),n(t,Gt,e),n(t,Z,e),n(t,bt,e),c(q,t,e),n(t,kt,e),n(t,O,e),n(t,Ct,e),n(t,N,e),n(t,Pt,e),c(z,t,e),n(t,Lt,e),n(t,Q,e),n(t,Ht,e),c(V,t,e),n(t,_t,e),n(t,T,e),n(t,Et,e),n(t,D,e),n(t,Ut,e),n(t,x,e),n(t,St,e),c(K,t,e),n(t,It,e),n(t,X,e),n(t,Jt,e),c(R,t,e),n(t,Wt,e),n(t,tt,e),n(t,Yt,e),c(et,t,e),n(t,jt,e),n(t,it,e),n(t,Bt,e),c(M,t,e),n(t,Ft,e),n(t,nt,e),At=!0},p(t,[e]){const ve={};e&2&&(ve.$$scope={dirty:e,ctx:t}),M.$set(ve)},i(t){At||(d(u.$$.fragment,t),d(_.$$.fragment,t),d(A.$$.fragment,t),d(q.$$.fragment,t),d(z.$$.fragment,t),d(V.$$.fragment,t),d(K.$$.fragment,t),d(R.$$.fragment,t),d(et.$$.fragment,t),d(M.$$.fragment,t),At=!0)},o(t){h(u.$$.fragment,t),h(_.$$.fragment,t),h(A.$$.fragment,t),h(q.$$.fragment,t),h(z.$$.fragment,t),h(V.$$.fragment,t),h(K.$$.fragment,t),h(R.$$.fragment,t),h(et.$$.fragment,t),h(M.$$.fragment,t),At=!1},d(t){t&&(i(p),i($),i(v),i(w),i(G),i(st),i(b),i(at),i(k),i(rt),i(C),i(ut),i(P),i(mt),i(L),i(pt),i(H),i(gt),i(ft),i(E),i(ct),i(U),i(dt),i(S),i(ht),i(I),i(yt),i(J),i(vt),i(W),i($t),i(Y),i(wt),i(j),i(Tt),i(B),i(xt),i(F),i(Mt),i(Gt),i(Z),i(bt),i(kt),i(O),i(Ct),i(N),i(Pt),i(Lt),i(Q),i(Ht),i(_t),i(T),i(Et),i(D),i(Ut),i(x),i(St),i(It),i(X),i(Jt),i(Wt),i(tt),i(Yt),i(jt),i(it),i(Bt),i(Ft),i(nt)),i(m),y(u,t),y(_,t),y(A,t),y(q,t),y(z,t),y(V,t),y(K,t),y(R,t),y(et,t),y(M,t)}}}const Ee='{"title":"Signing commits with GPG","local":"signing-commits-with-gpg","sections":[{"title":"Setting up signed commits verification","local":"setting-up-signed-commits-verification","sections":[],"depth":2},{"title":"Generating a new GPG key","local":"generating-a-new-gpg-key","sections":[],"depth":2},{"title":"Adding a GPG key to your account","local":"adding-a-gpg-key-to-your-account","sections":[],"depth":2},{"title":"Configure git to sign your commits with GPG","local":"configure-git-to-sign-your-commits-with-gpg","sections":[],"depth":2}],"depth":1}';function Ue(ot){return Me(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class je extends be{constructor(m){super(),ke(this,m,Ue,_e,xe,{})}}export{je as component};
